--- sys/i386/linux/linux_machdep.c.orig
+++ sys/i386/linux/linux_machdep.c
@@ -73,18 +73,6 @@
 
 extern struct sysentvec elf32_freebsd_sysvec;	/* defined in i386/i386/elf_machdep.c */
 
-struct l_descriptor {
-	l_uint		entry_number;
-	l_ulong		base_addr;
-	l_uint		limit;
-	l_uint		seg_32bit:1;
-	l_uint		contents:2;
-	l_uint		read_exec_only:1;
-	l_uint		limit_in_pages:1;
-	l_uint		seg_not_present:1;
-	l_uint		useable:1;
-};
-
 struct l_old_select_argv {
 	l_int		nfds;
 	l_fd_set	*readfds;
@@ -137,7 +125,7 @@
 	if (error == 0)
 		error = kern_execve(td, &eargs, NULL);
 	if (error == 0)
-	   	/* linux process can exec fbsd one, dont attempt
+	   	/* linux process can exec fbsd one, don't attempt
 		 * to create emuldata for such process using
 		 * linux_proc_init, this leads to a panic on KASSERT
 		 * because such process has p->p_emuldata == NULL
@@ -459,9 +447,6 @@
 	/* and adjust it */
 
 	if (args->flags & LINUX_CLONE_THREAD) {
-	   	/* XXX: linux mangles pgrp and pptr somehow
-		 * I think it might be this but I am not sure.
-		 */
 #ifdef notyet
 	   	PROC_LOCK(p2);
 	   	p2->p_pgrp = td->td_proc->p_pgrp;
@@ -873,7 +858,7 @@
 {
 	int error;
 	struct i386_ldt_args ldt;
-	struct l_descriptor ld;
+	struct l_user_desc ld;
 	union descriptor desc;
 
 	if (uap->ptr == NULL)
@@ -968,7 +953,7 @@
 }
 
 /*
- * Linux has two extra args, restart and oldmask.  We dont use these,
+ * Linux has two extra args, restart and oldmask.  We don't use these,
  * but it seems that "restart" is actually a context pointer that
  * enables the signal to happen with a different register set.
  */
@@ -1110,12 +1095,12 @@
 	idx = info.entry_number;
 	/* 
 	 * Semantics of linux version: every thread in the system has array of
-	 * 3 tls descriptors. 1st is GLIBC TLS, 2nd is WINE, 3rd unknown. This 
+	 * 3 tls descriptors. 1st is GLIBC TLS, 2nd is WINE, 3rd unknown. This
 	 * syscall loads one of the selected tls decriptors with a value and
 	 * also loads GDT descriptors 6, 7 and 8 with the content of the
 	 * per-thread descriptors.
 	 *
-	 * Semantics of fbsd version: I think we can ignore that linux has 3 
+	 * Semantics of fbsd version: I think we can ignore that linux has 3
 	 * per-thread descriptors and use just the 1st one. The tls_array[]
 	 * is used only in set/get-thread_area() syscalls and for loading the
 	 * GDT descriptors. In fbsd we use just one GDT descriptor for TLS so
--- sys/i386/linux/linux_sysvec.c.orig
+++ sys/i386/linux/linux_sysvec.c
@@ -917,7 +917,7 @@
 				linux_ioctl_register_handler(*lihp);
 			SET_FOREACH(ldhp, linux_device_handler_set)
 				linux_device_register_handler(*ldhp);
-			sx_init(&emul_lock, "emuldata lock");
+			mtx_init(&emul_lock, "emuldata lock", NULL, MTX_DEF);
 			sx_init(&emul_shared_lock, "emuldata->shared lock");
 			LIST_INIT(&futex_list);
 			sx_init(&futex_sx, "futex protection lock");
@@ -948,7 +948,7 @@
 				linux_ioctl_unregister_handler(*lihp);
 			SET_FOREACH(ldhp, linux_device_handler_set)
 				linux_device_unregister_handler(*ldhp);
-			sx_destroy(&emul_lock);
+			mtx_destroy(&emul_lock);
 			sx_destroy(&emul_shared_lock);
 			sx_destroy(&futex_sx);
 			EVENTHANDLER_DEREGISTER(process_exit, linux_exit_tag);
--- sys/i386/linux/syscalls.master.orig
+++ sys/i386/linux/syscalls.master
@@ -117,7 +117,7 @@
 58	AUE_NULL	UNIMPL	ulimit
 59	AUE_NULL	STD	{ int linux_olduname(void); }
 60	AUE_UMASK	NOPROTO	{ int umask(int newmask); }
-61	AUE_CHROOT	NOPROTO	{ int chroot(char *path); }
+61	AUE_CHROOT	STD	{ int linux_chroot(char *path); }
 62	AUE_NULL	STD	{ int linux_ustat(l_dev_t dev, \
 				    struct l_ustat *ubuf); }
 63	AUE_DUP2	NOPROTO { int dup2(u_int from, u_int to); }
@@ -333,7 +333,8 @@
 185	AUE_CAPSET	STD	{ int linux_capset(void); }
 186	AUE_NULL	STD	{ int linux_sigaltstack(l_stack_t *uss, \
 				    l_stack_t *uoss); }
-187	AUE_SENDFILE	STD	{ int linux_sendfile(void); }
+187	AUE_SENDFILE	STD	{ int linux_sendfile(int out, int in, l_long *offset, \
+				    l_size_t count); }
 188	AUE_GETPMSG	UNIMPL	getpmsg
 189	AUE_PUTPMSG	UNIMPL	putpmsg
 190	AUE_VFORK	STD	{ int linux_vfork(void); }
@@ -408,16 +409,17 @@
 238	AUE_NULL	STD	{ int linux_tkill(int tid, int sig); }
 239	AUE_SENDFILE	UNIMPL	linux_sendfile64
 240	AUE_NULL	STD	{ int linux_sys_futex(void *uaddr, int op, int val, \
-					struct l_timespec *timeout, void *uaddr2, int val3); }
+				    struct l_timespec *timeout, void *uaddr2, int val3); }
 241	AUE_NULL	UNIMPL	linux_sched_setaffinity
-242	AUE_NULL	UNIMPL	linux_sched_getaffinity
+242	AUE_NULL	STD	{ int linux_sched_getaffinity(l_pid_t pid, l_uint cpusetsize, \
+				    l_ulong *mask); }
 243	AUE_NULL	STD	{ int linux_set_thread_area(struct l_user_desc *desc); }
 244	AUE_NULL	STD	{ int linux_get_thread_area(struct l_user_desc *desc); }
-245	AUE_NULL	UNIMPL	linux_io_setup
-246	AUE_NULL	UNIMPL	linux_io_destroy
-247	AUE_NULL	UNIMPL	linux_io_getevents
-248	AUE_NULL	UNIMPL	linux_io_submit
-249	AUE_NULL	UNIMPL	linux_io_cancel
+245	AUE_NULL	STD	{ int linux_io_setup(l_uint nr_reqs, linux_aio_context_t *ctxp); }
+246	AUE_NULL	STD	{ int linux_io_destroy(linux_aio_context_t ctx); }
+247	AUE_NULL	STD	{ int linux_io_getevents(linux_aio_context_t ctx_id, l_long min_nr, l_long nr, struct linux_io_event *events, struct l_timespec *timeout); }
+248	AUE_NULL	STD	{ int linux_io_submit(linux_aio_context_t ctx_id, l_long nr, struct linux_iocb **iocbpp); }
+249	AUE_NULL	STD	{ int linux_io_cancel(linux_aio_context_t ctx_id, struct linux_iocb *iocb, struct linux_io_event *result); }
 250	AUE_NULL	STD	{ int linux_fadvise64(void); }
 251	AUE_NULL	UNIMPL
 252	AUE_EXIT	STD	{ int linux_exit_group(int error_code); }
@@ -473,7 +475,8 @@
 292	AUE_NULL	STD	{ int linux_inotify_add_watch(void); }
 293	AUE_NULL	STD	{ int linux_inotify_rm_watch(void); }
 294	AUE_NULL	STD	{ int linux_migrate_pages(void); }
-295	AUE_NULL	STD	{ int linux_openat(void); }
+295	AUE_OPEN_RWTC	STD	{ int linux_openat(l_int dfd, char *filename, \
+					l_int flags, l_int mode); }
 296	AUE_NULL	STD	{ int linux_mkdirat(void); }
 297	AUE_NULL	STD	{ int linux_mknodat(void); }
 298	AUE_NULL	STD	{ int linux_fchownat(void); }
--- sys/kern/kern_fork.c.orig
+++ sys/kern/kern_fork.c
@@ -522,10 +522,11 @@
 		sigacts_copy(newsigacts, p1->p_sigacts);
 		p2->p_sigacts = newsigacts;
 	}
-	if (flags & RFLINUXTHPN) 
-	        p2->p_sigparent = SIGUSR1;
+	/* This flag is used by linuxthreads and is passed in via rfork(). */
+	if (flags & RFLINUXTHPN)
+	   	p2->p_sigparent = SIGUSR1;
 	else
-	        p2->p_sigparent = SIGCHLD;
+   	   	p2->p_sigparent = SIGCHLD;
 
 	p2->p_textvp = p1->p_textvp;
 	p2->p_fd = fd;
--- sys/kern/vfs_aio.c.orig
+++ sys/kern/vfs_aio.c
@@ -139,8 +139,8 @@
 SYSCTL_INT(_vfs_aio, OID_AUTO, target_aio_procs, CTLFLAG_RW, &target_aio_procs,
 	0, "Preferred number of ready kernel threads for async IO");
 
-static int max_queue_count = MAX_AIO_QUEUE;
-SYSCTL_INT(_vfs_aio, OID_AUTO, max_aio_queue, CTLFLAG_RW, &max_queue_count, 0,
+int max_aio_queue_count = MAX_AIO_QUEUE;
+SYSCTL_INT(_vfs_aio, OID_AUTO, max_aio_queue, CTLFLAG_RW, &max_aio_queue_count, 0,
     "Maximum number of aio requests to queue, globally");
 
 static int num_queue_count = 0;
@@ -172,7 +172,7 @@
 SYSCTL_INT(_vfs_aio, OID_AUTO, max_aio_per_proc, CTLFLAG_RW, &max_aio_per_proc,
     0, "Maximum active aio requests per process (stored in the process)");
 
-static int max_aio_queue_per_proc = MAX_AIO_QUEUE_PER_PROC;
+int max_aio_queue_per_proc = MAX_AIO_QUEUE_PER_PROC;
 SYSCTL_INT(_vfs_aio, OID_AUTO, max_aio_queue_per_proc, CTLFLAG_RW,
     &max_aio_queue_per_proc, 0,
     "Maximum queued aio requests per process (stored in the process)");
@@ -257,19 +257,6 @@
 	struct thread *aiothread;		/* (*) the AIO thread */
 };
 
-/*
- * data-structure for lio signal management
- */
-struct aioliojob {
-	int	lioj_flags;			/* (a) listio flags */
-	int	lioj_count;			/* (a) listio flags */
-	int	lioj_finished_count;		/* (a) listio flags */
-	struct	sigevent lioj_signal;		/* (a) signal on all I/O done */
-	TAILQ_ENTRY(aioliojob) lioj_list;	/* (a) lio list */
-	struct  knlist klist;			/* (a) list of knotes */
-	ksiginfo_t lioj_ksi;			/* (a) Realtime signal info */
-};
-
 #define	LIOJ_SIGNAL		0x1	/* signal on all done (lio) */
 #define	LIOJ_SIGNAL_POSTED	0x2	/* signal has been posted */
 #define LIOJ_KEVENT_POSTED	0x4	/* kevent triggered */
@@ -313,13 +300,10 @@
 static TAILQ_HEAD(,aiocblist) aio_jobs;			/* (c) Async job list */
 static struct unrhdr *aiod_unr;
 
-void		aio_init_aioinfo(struct proc *p);
 static void	aio_onceonly(void);
 static int	aio_free_entry(struct aiocblist *aiocbe);
 static void	aio_process(struct aiocblist *aiocbe);
 static int	aio_newproc(int *);
-int		aio_aqueue(struct thread *td, struct aiocb *job,
-			struct aioliojob *lio, int type, int osigev);
 static void	aio_physwakeup(struct buf *bp);
 static void	aio_proc_rundown(void *arg, struct proc *p);
 static void	aio_proc_rundown_exec(void *arg, struct proc *p, struct image_params *imgp);
@@ -1347,7 +1331,7 @@
 	suword(&job->_aiocb_private.error, 0);
 	suword(&job->_aiocb_private.kernelinfo, -1);
 
-	if (num_queue_count >= max_queue_count ||
+	if (num_queue_count >= max_aio_queue_count ||
 	    ki->kaio_count >= ki->kaio_qallowed_count) {
 		suword(&job->_aiocb_private.error, EAGAIN);
 		return (EAGAIN);
--- sys/modules/Makefile.orig
+++ sys/modules/Makefile
@@ -141,6 +141,7 @@
 	${_linprocfs} \
 	${_linsysfs} \
 	${_linux} \
+	${_linuxaio} \
 	lmc \
 	lpt \
 	mac_biba \
@@ -374,6 +375,7 @@
 _linprocfs=	linprocfs
 _linsysfs=	linsysfs
 _linux=		linux
+_linuxaio=	linuxaio
 _mse=		mse
 .if ${MK_NCP} != "no"
 _ncp=		ncp
@@ -485,6 +487,7 @@
 _linprocfs=	linprocfs
 _linsysfs=	linsysfs
 _linux=		linux
+_linuxaio=	linuxaio
 _mly=		mly
 _mxge=		mxge
 _ndis=		ndis
@@ -504,8 +507,8 @@
 
 .if ${MACHINE_ARCH} == "ia64"
 # Modules not enabled on ia64 (as compared to i386) include:
-#	aac acpi aout apm atspeaker drm ibcs2 linprocfs linux ncv
-#	nsp oltr pecoff s3 sbni stg vesa
+#	aac acpi aout apm atspeaker drm ibcs2 linsysfs linprocfs linux
+#	linuxaio ncv nsp oltr pecoff s3 sbni stg vesa
 # acpi is not enabled because it is broken as a module on ia64
 _aic=		aic
 #_ar=		ar	not 64-bit clean
--- sys/modules/aio/Makefile.orig
+++ sys/modules/aio/Makefile
@@ -5,6 +5,7 @@
 KMOD=	aio
 SRCS=	vfs_aio.c opt_vfs_aio.h vnode_if.h
 
-EXPORT_SYMS= aio_init_aioinfo aio_aqueue
+EXPORT_SYMS= aio_init_aioinfo aio_aqueue max_aio_queue_count \
+	max_aio_queue_per_proc
 
 .include <bsd.kmod.mk>
--- /dev/null	Sat Mar 17 17:03:38 2007
+++ sys/modules/linuxaio/Makefile	Sat Mar 17 17:03:41 2007
@@ -0,0 +1,12 @@
+# $FreeBSD: src/linuxaio/Makefile,v 1.1 2007/01/25 14:39:24 admin Exp $
+
+.if ${MACHINE_ARCH} == "amd64"
+CFLAGS+=-DCOMPAT_LINUX32
+.endif
+
+.PATH:  ${.CURDIR}/../../compat/linux
+
+KMOD=	linuxaio
+SRCS=	linux_aio.c linux_aio.h opt_compat.h
+
+.include <bsd.kmod.mk>
--- sys/pc98/conf/NOTES.orig
+++ sys/pc98/conf/NOTES
@@ -695,6 +695,9 @@
 # and PSEUDOFS)
 options 	LINSYSFS
 
+# Enable the linux aio support (requires COMPAT_LINUX and VFS_AIO)
+options 	LINUXAIO
+
 #
 # SysVR4 ABI emulation
 #
--- sys/sys/aio.h.orig
+++ sys/sys/aio.h
@@ -23,6 +23,12 @@
 #include <sys/types.h>
 #include <sys/signal.h>
 
+#ifdef _KERNEL
+#include <sys/event.h>
+#include <sys/queue.h>
+#include <sys/signalvar.h>
+#endif
+
 /*
  * Returned by aio_cancel:
  */
@@ -135,6 +141,28 @@
 
 extern void (*aio_swake)(struct socket *, struct sockbuf *);
 
+/* To be used by the Linux AIO module */
+extern int max_aio_queue_count;
+extern int max_aio_queue_per_proc;
+
+/*
+ * data-structure for lio signal management
+ */
+struct aioliojob {
+	int	lioj_flags;			/* (a) listio flags */
+	int	lioj_count;			/* (a) listio flags */
+	int	lioj_finished_count;		/* (a) listio flags */
+	struct	sigevent lioj_signal;		/* (a) signal on all I/O done */
+	TAILQ_ENTRY(aioliojob) lioj_list;	/* (a) lio list */
+	struct  knlist klist;			/* (a) list of knotes */
+	ksiginfo_t lioj_ksi;			/* (a) Realtime signal info */
+};
+
+/* To be used by the Linux AIO module */
+extern void aio_init_aioinfo(struct proc *p);
+extern int aio_aqueue(struct thread *td, struct aiocb *job,
+	struct aioliojob *lio, int type, int osigev);
+
 #endif
 
 #endif
